package net.mcreator.jays_mod;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;

import net.minecraft.util.ResourceLocation;
import net.minecraft.potion.PotionEffect;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.init.Items;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.Minecraft;

import java.util.List;
import java.util.ArrayList;

public class MCreatorAstralWaterBottle extends jays_mod.ModElement {

	@GameRegistry.ObjectHolder("jays_mod:astralwaterbottle")
	public static final Potion potion = null;

	public MCreatorAstralWaterBottle(jays_mod instance) {
		super(instance);
		instance.potions.add(() -> new PotionCustom());
	}

	public static class PotionCustom extends Potion {

		private final ResourceLocation potionIcon;

		public PotionCustom() {
			super(false, -6736897);
			setBeneficial();
			setRegistryName("astralwaterbottle");
			setPotionName("effect.astralwaterbottle");
			potionIcon = new ResourceLocation("jays_mod:textures/astral_heal.png");
		}

		@Override
		public boolean isInstant() {
			return false;
		}

		@Override
		public List<ItemStack> getCurativeItems() {
			List<ItemStack> ret = new ArrayList<>();
			ret.add(new ItemStack(Items.MILK_BUCKET, (int) (1)));
			return ret;
		}

		@Override
		public boolean shouldRenderInvText(PotionEffect effect) {
			return true;
		}

		@Override
		public boolean shouldRenderHUD(PotionEffect effect) {
			return true;
		}

		@SideOnly(Side.CLIENT)
		@Override
		public void renderInventoryEffect(int x, int y, PotionEffect effect, Minecraft mc) {
			if (mc.currentScreen != null) {
				mc.getTextureManager().bindTexture(potionIcon);
				Gui.drawModalRectWithCustomSizedTexture(x + 6, y + 7, 0, 0, 18, 18, 18, 18);
			}
		}

		@SideOnly(Side.CLIENT)
		@Override
		public void renderHUDEffect(int x, int y, PotionEffect effect, Minecraft mc, float alpha) {
			mc.getTextureManager().bindTexture(potionIcon);
			Gui.drawModalRectWithCustomSizedTexture(x + 3, y + 3, 0, 0, 18, 18, 18, 18);
		}

		@Override
		public boolean isReady(int duration, int amplifier) {
			return true;
		}
	}
}
