package net.mcreator.jays_mod;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = jays_mod.MODID, version = jays_mod.VERSION)
public class jays_mod implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "jays_mod";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "net.mcreator.jays_mod.ClientProxyjays_mod", serverSide = "net.mcreator.jays_mod.CommonProxyjays_mod")
	public static CommonProxyjays_mod proxy;
	@Instance(MODID)
	public static jays_mod instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();
	public final List<Supplier<Potion>> potions = new ArrayList<>();

	public jays_mod() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new MCreatorStarOre(this));
		elements.add(new MCreatorJaysMod(this));
		elements.add(new MCreatorStarGem(this));
		elements.add(new MCreatorStarDust(this));
		elements.add(new MCreatorStarGemRecipe(this));
		elements.add(new MCreatorStarIngot(this));
		elements.add(new MCreatorStarSwordRecipe(this));
		elements.add(new MCreatorStarPickaxe(this));
		elements.add(new MCreatorStarPickaxeRecipe(this));
		elements.add(new MCreatorStarAxe(this));
		elements.add(new MCreatorStarAxeRecipe(this));
		elements.add(new MCreatorStarShovel(this));
		elements.add(new MCreatorStarShovelRecipe(this));
		elements.add(new MCreatorStarHoe(this));
		elements.add(new MCreatorStarHoeProcedure(this));
		elements.add(new MCreatorStarSword(this));
		elements.add(new MCreatorStarArmorSet(this));
		elements.add(new MCreatorStarHelmetRecipe(this));
		elements.add(new MCreatorStarChestplateRecipe(this));
		elements.add(new MCreatorStarLeggingsRecipe(this));
		elements.add(new MCreatorStarBootsRecipe(this));
		elements.add(new MCreatorShiny(this));
		elements.add(new MCreatorShinyAchievement(this));
		elements.add(new MCreatorStarFuel(this));
		elements.add(new MCreatorAstralLiquid(this));
		elements.add(new MCreatorAstralLiquidProdecure(this));
		elements.add(new MCreatorAstralOre(this));
		elements.add(new MCreatorAstralOreMelt(this));
		elements.add(new MCreatorAstralOreFreeze(this));
		elements.add(new MCreatorAstralFreeze(this));
		elements.add(new MCreatorAstralFreezeProcedure(this));
		elements.add(new MCreatorAstralStone(this));
		elements.add(new MCreatorAstralBucketProcedure(this));
		elements.add(new MCreatorAstralBucket(this));
		elements.add(new MCreatorPotionOfAstralFreezeProcedure(this));
		elements.add(new MCreatorPotionOfAstralFreeze(this));
		elements.add(new MCreatorPotionOfAstralFreezeIIProcedure(this));
		elements.add(new MCreatorPotionOfAstralFreezeII(this));
		elements.add(new MCreatorMadeOfStars(this));
		elements.add(new MCreatorMadeOfStarsAchievement(this));
		elements.add(new MCreatorAstralDimensionBiome(this));
		elements.add(new MCreatorStarBrick(this));
		elements.add(new MCreatorAstralDimension(this));
		elements.add(new MCreatorAstralScourger(this));
		elements.add(new MCreatorAstralFire(this));
		elements.add(new MCreatorAstralFireProcedure(this));
		elements.add(new MCreatorButterlord(this));
		elements.add(new MCreatorButterlordAchievement(this));
		elements.add(new MCreatorAstralChargeProcedure(this));
		elements.add(new MCreatorAstralCharge(this));
		elements.add(new MCreatorStarFountain(this));
		elements.add(new MCreatorStarChest(this));
		elements.add(new MCreatorStarChestGUI(this));
		elements.add(new MCreatorStarChestOpen(this));
		elements.add(new MCreatorTrapStarBrickProcedure(this));
		elements.add(new MCreatorTrapStarBrick(this));
		elements.add(new MCreatorScourgeOfTheUniverse(this));
		elements.add(new MCreatorScourgeOfTheUniverseAchievement(this));
		elements.add(new MCreatorStarChestGUILootAll(this));
		elements.add(new MCreatorPity(this));
		elements.add(new MCreatorPityAchievement(this));
		elements.add(new MCreatorAstralZombie(this));
		elements.add(new MCreatorAstralBar(this));
		elements.add(new MCreatorStarHoeRecipe(this));
		elements.add(new MCreatorAstralBarRecipe(this));
		elements.add(new MCreatorAstralLog(this));
		elements.add(new MCreatorAstralLeaves(this));
		elements.add(new MCreatorAstralPillar(this));
		elements.add(new MCreatorAstralBricks(this));
		elements.add(new MCreatorAstralBricksRecipe(this));
		elements.add(new MCreatorAstralPortal(this));
		elements.add(new MCreatorAstralPortalNetherSpawn(this));
		elements.add(new MCreatorAstralFort1Spawn(this));
		elements.add(new MCreatorAstralTotemUseProcedure(this));
		elements.add(new MCreatorAstralTotem(this));
		elements.add(new MCreatorAstriusSpawner(this));
		elements.add(new MCreatorAstrius(this));
		elements.add(new MCreatorSpawnAstrius(this));
		elements.add(new MCreatorAstriusLoot(this));
		elements.add(new MCreatorAstriusSpawn(this));
		elements.add(new MCreatorAstriusDungeon1(this));
		elements.add(new MCreatorAstriusDungeon1SchematicPlace(this));
		elements.add(new MCreatorAstriusDungeon1Schematic(this));
		elements.add(new MCreatorAstralFort1SchematicPlace(this));
		elements.add(new MCreatorAstralFort1Schematic(this));
		elements.add(new MCreatorStarBeacon(this));
		elements.add(new MCreatorAstralZombieInfected(this));
		elements.add(new MCreatorHero(this));
		elements.add(new MCreatorAstralPlanks(this));
		elements.add(new MCreatorAstralPlanksRecipe(this));
		elements.add(new MCreatorAstralLogFuel(this));
		elements.add(new MCreatorAstralWoodFuel(this));
		elements.add(new MCreatorAstralHouseL1(this));
		elements.add(new MCreatorAstralHouseL1SchematicPlace(this));
		elements.add(new MCreatorAstralHouseL1Schematic(this));
		elements.add(new MCreatorHeroAchievement(this));
		elements.add(new MCreatorAstralHouseL2(this));
		elements.add(new MCreatorAstralHouseL2Schematic(this));
		elements.add(new MCreatorAstralHouseL2SchematicPlace(this));
		elements.add(new MCreatorAstriusSecondAI(this));
		elements.add(new MCreatorAstreussSpark(this));
		elements.add(new MCreatorAstralSword(this));
		elements.add(new MCreatorAstralSwordRecipe(this));
		elements.add(new MCreatorAstralGunHitEffect(this));
		elements.add(new MCreatorAstralGun(this));
		elements.add(new MCreatorAstralGunRecipe(this));
		elements.add(new MCreatorOverkill2(this));
		elements.add(new MCreatorGunsInMC(this));
		elements.add(new MCreatorGunsInMCAchievement(this));
		elements.add(new MCreatorOverkill2Achievement(this));
		elements.add(new MCreatorAstralBullet(this));
		elements.add(new MCreatorAstralBulletRecipe(this));
		elements.add(new MCreatorZap(this));
		elements.add(new MCreatorAstralGunUsed(this));
		elements.add(new MCreatorNetherRift(this));
		elements.add(new MCreatorNetherRiftSpawner(this));
		elements.add(new MCreatorHostilePigman(this));
		elements.add(new MCreatorHostilePigmanLeader(this));
		elements.add(new MCreatorZpigLeaderDowned(this));
		elements.add(new MCreatorLesserPigman(this));
		elements.add(new MCreatorZpigLeaderHurt(this));
		elements.add(new MCreatorBigPig(this));
		elements.add(new MCreatorAstralMeteorDimensionSpawn(this));
		elements.add(new MCreatorStarBrickRecipe(this));
		elements.add(new MCreatorAstralTower1(this));
		elements.add(new MCreatorAstralMeteor1Schematic(this));
		elements.add(new MCreatorAstralMeteor1SchematicPlace(this));
		elements.add(new MCreatorNetherFlagGuard(this));
		elements.add(new MCreatorNetherFlag(this));
		elements.add(new MCreatorBigPigAchievement(this));
		elements.add(new MCreatorZpigLeaderClearFlags(this));
		elements.add(new MCreatorAstriusSummonFromItem(this));
		elements.add(new MCreatorAstriusInfectedCrystal(this));
		elements.add(new MCreatorCrystallineAstralChunk(this));
		elements.add(new MCreatorCrystallineAstralChunkRecipe(this));
		elements.add(new MCreatorInfectedCrystalRecipe(this));
		elements.add(new MCreatorTropical(this));
		elements.add(new MCreatorTropicalHideout(this));
		elements.add(new MCreatorTropicalDimensionAchievement(this));
		elements.add(new MCreatorTropicalDimension(this));
		elements.add(new MCreatorPalmLog(this));
		elements.add(new MCreatorPalmLeaves(this));
		elements.add(new MCreatorTropicsGrasslands(this));
		elements.add(new MCreatorReadAstriusNote(this));
		elements.add(new MCreatorAstriusNote(this));
		elements.add(new MCreatorAstralNoteGUI(this));
		elements.add(new MCreatorAstralNoteBurn(this));
		elements.add(new MCreatorPalmLeafProcedure(this));
		elements.add(new MCreatorPalmLeaf(this));
		elements.add(new MCreatorIceCreamConeProcedure(this));
		elements.add(new MCreatorIceCreamCone(this));
		elements.add(new MCreatorLeaf(this));
		elements.add(new MCreatorBrainFreeze(this));
		elements.add(new MCreatorIceCremRecipe(this));
		elements.add(new MCreatorAstralWaterBottle(this));
		elements.add(new MCreatorAstralHealProcedure(this));
		elements.add(new MCreatorPotionOfAstralLiquid(this));
		elements.add(new MCreatorAstralWaterBottleDrink(this));
		elements.add(new MCreatorHealingPotionIIIConsumed(this));
		elements.add(new MCreatorHealingPotionIII(this));
		elements.add(new MCreatorHealingPotionIIIRecipe(this));
		elements.add(new MCreatorHealingPotionIV(this));
		elements.add(new MCreatorHealingPotionIVConsumed(this));
		elements.add(new MCreatorHealingPotionIVRecipe(this));
		elements.add(new MCreatorHealingPotionIVRecipe2(this));
		elements.add(new MCreatorAstriusHurt(this));
		elements.add(new MCreatorPalmArrow(this));
		elements.add(new MCreatorPalmBowProjectileProcedure(this));
		elements.add(new MCreatorPalmBow(this));
		elements.add(new MCreatorPalmBowUseProcedure(this));
		elements.add(new MCreatorTropicalSand(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerPotions(RegistryEvent.Register<Potion> event) {
		event.getRegistry().registerAll(potions.stream().map(Supplier::get).toArray(Potion[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
		ResourceLocation sound0 = new ResourceLocation("jays_mod", "ScourgerDeath");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound0).setRegistryName(sound0));
		ResourceLocation sound1 = new ResourceLocation("jays_mod", "ScourgerLaugh");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound1).setRegistryName(sound1));
		ResourceLocation sound2 = new ResourceLocation("jays_mod", "ScourgerScream");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound2).setRegistryName(sound2));
		ResourceLocation sound3 = new ResourceLocation("jays_mod", "StarChestOpen");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound3).setRegistryName(sound3));
		ResourceLocation sound4 = new ResourceLocation("jays_mod", "AstralZombieDeath");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound4).setRegistryName(sound4));
		ResourceLocation sound5 = new ResourceLocation("jays_mod", "AstralZombieHurt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound5).setRegistryName(sound5));
		ResourceLocation sound6 = new ResourceLocation("jays_mod", "AstralZombieIdle");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound6).setRegistryName(sound6));
		ResourceLocation sound7 = new ResourceLocation("jays_mod", "AstralPortal");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound7).setRegistryName(sound7));
		ResourceLocation sound8 = new ResourceLocation("jays_mod", "AstriusDeath");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound8).setRegistryName(sound8));
		ResourceLocation sound9 = new ResourceLocation("jays_mod", "AstriusTaunt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound9).setRegistryName(sound9));
		ResourceLocation sound10 = new ResourceLocation("jays_mod", "AstriusHurt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound10).setRegistryName(sound10));
		ResourceLocation sound11 = new ResourceLocation("jays_mod", "InfectedDeath");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound11).setRegistryName(sound11));
		ResourceLocation sound12 = new ResourceLocation("jays_mod", "InfectedHurt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound12).setRegistryName(sound12));
		ResourceLocation sound13 = new ResourceLocation("jays_mod", "InfectedTip");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound13).setRegistryName(sound13));
		ResourceLocation sound14 = new ResourceLocation("jays_mod", "AstriusSummon");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound14).setRegistryName(sound14));
		ResourceLocation sound15 = new ResourceLocation("jays_mod", "AstralGunFire");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound15).setRegistryName(sound15));
		ResourceLocation sound16 = new ResourceLocation("jays_mod", "ZpigLeaderIdle");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound16).setRegistryName(sound16));
		ResourceLocation sound17 = new ResourceLocation("jays_mod", "ZpigLeaderDie");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound17).setRegistryName(sound17));
		ResourceLocation sound18 = new ResourceLocation("jays_mod", "ZpigLeaderHurt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound18).setRegistryName(sound18));
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == MCreatorStarChestGUI.GUIID)
				return new MCreatorStarChestGUI.GuiContainerMod(world, x, y, z, player);
			if (id == MCreatorAstralNoteGUI.GUIID)
				return new MCreatorAstralNoteGUI.GuiContainerMod(world, x, y, z, player);
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == MCreatorStarChestGUI.GUIID)
				return new MCreatorStarChestGUI.GuiWindow(world, x, y, z, player);
			if (id == MCreatorAstralNoteGUI.GUIID)
				return new MCreatorAstralNoteGUI.GuiWindow(world, x, y, z, player);
			return null;
		}
	}

	public static class ModElement {

		public static jays_mod instance;

		public ModElement(jays_mod instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
