package net.mcreator.jays_mod;

import net.minecraftforge.fml.common.FMLCommonHandler;

import net.minecraft.world.WorldServer;
import net.minecraft.world.World;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.server.MinecraftServer;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.Entity;

import java.util.HashMap;

public class MCreatorNetherRift extends jays_mod.ModElement {

	public MCreatorNetherRift(jays_mod instance) {
		super(instance);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure MCreatorNetherRift!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure MCreatorNetherRift!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure MCreatorNetherRift!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure MCreatorNetherRift!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure MCreatorNetherRift!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:sand");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:dirt");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:grass");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:stone");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:grass_path");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:log");
		}
		if (entity instanceof EntityPlayerMP) {
			MinecraftServer mcserv = FMLCommonHandler.instance().getMinecraftServerInstance();
			if (mcserv != null)
				mcserv.getCommandManager().executeCommand((EntityPlayerMP) entity,
						"/fill ~5 ~5 ~5 ~-5 ~-5 ~-5 minecraft:netherrack 0 replace minecraft:log2");
		}
		world.addWeatherEffect(new EntityLightningBolt(world, (int) x, (int) (y + 1), (int) z, false));
		if (world instanceof WorldServer)
			((WorldServer) world).spawnParticle(EnumParticleTypes.PORTAL, x, y, z, (int) 300, 3, 3, 3, 0.5, new int[0]);
		for (int index0 = 0; index0 < (int) (5); index0++) {
			if (!world.isRemote) {
				Entity entityToSpawn = new MCreatorHostilePigman.EntityCustom(world);
				if (entityToSpawn != null) {
					entityToSpawn.setLocationAndAngles(x, (y + 1), z, world.rand.nextFloat() * 360F, 0.0F);
					world.spawnEntity(entityToSpawn);
				}
			}
		}
		if (!world.isRemote) {
			Entity entityToSpawn = new MCreatorHostilePigmanLeader.EntityCustom(world);
			if (entityToSpawn != null) {
				entityToSpawn.setLocationAndAngles(x, (y + 1), z, world.rand.nextFloat() * 360F, 0.0F);
				world.spawnEntity(entityToSpawn);
			}
		}
		if (entity instanceof EntityPlayer)
			((EntityPlayer) entity).inventory.clearMatchingItems(new ItemStack(MCreatorNetherRiftSpawner.block, (int) (1)).getItem(), -1, (int) 1,
					null);
	}
}
